"use strict";
this.name        = "shiplib";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Contains data about player ships.";
this.version     = "1.0";

//please configure these to your custom ship if not in the list below
this.$ShipLibViewPosition = { //must be equal with view_position_* of your ship in the shipdata.plist
	aft:[0.0, 7.5, -32.5], forward:[0.0, 7.25, 16.25], port:[-30.0, 4.75, 0.0], starboard:[30.0, 4.75, 0.0]};
	
//internal data, should not touch
this.$ShipLibVP = [
	{k:"default", a:this.$ShipLibViewPosition.aft, f:this.$ShipLibViewPosition.forward,
		p:this.$ShipLibViewPosition.port, s:this.$ShipLibViewPosition.starboard},
	//original player ships
	{k:"adder", a:[0.0, 2.5, -22.5], f:[0.0, 2.5, 14.0], p:[-12.0, 1.5, -1.0], s:[12.0, 1.5, -1.0]},
	{k:"anaconda", a:[0.0, -4.0, -80.0], f:[0.0, -0.5, 70.0], p:[-2.15, -0.5, 70.0], s:[2.15, -0.5, 70.0]},
	{k:"asp", a:[0.0, 5.0, -35.0], f:[0.0, 5.31, 17.5], p:[-27.0, 5.0, 0.0], s:[27.0, 5.0, 0.0]},
	{k:"boa", a:[0.0, 20.5, -50.75], f:[0.0, 16.25, 23.9], p:[-7.3, 16.25, -23.9], s:[7.3, 16.25, -23.9]},
	{k:"boa-mk2", a:[0.0, 22.875, -47.375], f:[0.0, 12.5, 19.4375], p:[-20.67, 11.17, -14.67], s:[20.67, 11.17, -14.67]},
	{k:"cobra", a:[0.0, 7.5, -32.5], f:[0.0, 7.25, 16.25], p:[-30.0, 4.75, 0.0], s:[30.0, 4.75, 0.0]},
	{k:"cobra3", a:[0.0, 7.5, -32.5], f:[0.0, 7.25, 16.25], p:[-30.0, 4.75, 0.0], s:[30.0, 4.75, 0.0]},
	{k:"cobramk1", a:[0.0, 3.75, -27.5], f:[0.0, 2.925, 15.125], p:[-13.0, 3.75, 0.0], s:[13.0, 3.75, 0.0]},
	{k:"ferdelance", a:[0.0, 5.0, -32.5], f:[0.0, 0.0, 9.0], p:[-16.875, 2.0, 3.5], s:[16.875, 2.0, 3.5]},
	{k:"moray", a:[0.0, 8.875, 5.5], f:[0.0, 4.4, 22.5], p:[-22.5, 5.25, 11.875], s:[22.5, 5.25, 11.875]},
	{k:"morayMED", a:[0.0, 8.875, 5.5], f:[0.0, 4.4, 22.5], p:[-22.5, 5.25, 11.875], s:[22.5, 5.25, 11.875]},
	{k:"python", a:[0.0, 15.0, -49.5], f:[0.0, 10.0, 31.5], p:[-16.0, 4.0, 15.2], s:[16.0, 4.0, 15.2]},
	//custom ships
	{k:"base", a:[0.0, 500.0, -400.0], f:[0.0, 3.0, 320.0], p:[-60.0, 3.0, 0.0], s:[60.0, 3.0, 0.0]},
	{k:"corvette", a:[0.0, 6.0, -16.5], f:[0.0, 3.0, 16.5], p:[-5.0, 2.0, 0.0], s:[5.0, 2.0, 0.0]},
	{k:"cruiser", a:[0.0, 3.0, -120.0], f:[0.0, 3.0, 120.0], p:[-60.0, 3.0, 0.0], s:[60.0, 3.0, 0.0]},
	{k:"drone", a:[0.0, 5.0, -6.5], f:[0.0, 3.0, 9.5], p:[-2.5, 2.0, 0.0], s:[2.5, 2.0, 0.0]},
	{k:"freighter", a:[0.0, 3.0, -120.0], f:[0.0, 3.0, 120.0], p:[-60.0, 3.0, 0.0], s:[60.0, 3.0, 0.0]},
	{k:"frigate", a:[0.0, 30.0, -50.0], f:[0.0, 3.0, 50.0], p:[-30.0, 0.0, 0.0], s:[30.0, 0.0, 0.0]},
	{k:"fighter", a:[0.0, 6.0, -16.5], f:[0.0, 3.0, 16.5], p:[-5.0, 2.0, 0.0], s:[5.0, 2.0, 0.0]},
	{k:"gunship", a:[0.0, 6.0, -16.5], f:[0.0, 3.0, 16.5], p:[-5.0, 2.0, 0.0], s:[5.0, 2.0, 0.0]},
	{k:"miner", a:[0.0, 30.0, -50.0], f:[0.0, 3.0, 50.0], p:[-30.0, 0.0, 0.0], s:[30.0, 0.0, 0.0]},
	{k:"runner", a:[0.0, 6.0, -16.5], f:[0.0, 3.0, 16.5], p:[-5.0, 2.0, 0.0], s:[5.0, 2.0, 0.0]},
	];
