"use strict";
this.name        = "telescopeeq";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 4.0";
this.description = "Commands and settings, press mode to cycle, activate to accept or change.";
this.version     = "1.9";

this.$Telescopeeq_Menu = [ [ "Nearest target" ],
	[ "Rescan" ],
	[ "Step forward in the target list" ],
	[ "Step back in the target list" ],
	[ "Lightballs:", "off", "navigation only", "ships", "masslock borders", "large" ],
	[ "Sniper ring km:", "off", "5-25.6", "10-25.6", "15-25.6", "5-30", "10-30", "15-30"], //off=10-10
	[ "Steering:", "off", "nearest target only", "both nearest and step in the list"],
	[ "Targets:", "20 and limitation in red alert", 50, 100, 200 ],
	[ "Visual target:", "off", "weapons off", "no ring", "no station", "no question mark", "all" ],
	[ "Visual target size:", 1, 2, 3, 4, 5, 6, 7, 8 ] ];
this.$Telescopeeq_MenuItem = 0; //current item in the commands or settings menu

//equipment events
this.activated = function ()
{
	var w = worldScripts["telescope"];
	var menu = this.$Telescopeeq_Menu;
	var item = this.$Telescopeeq_MenuItem;
	if( item < 4 ) { //commands
		switch( item ) {
			case 0: //Nearest target
				w.$Telescope_Nearest(); //lock the nearest target
				if( w.$TelescopeSteering > 0 )
					w.$Telescope_Steer();//turn to the target
				break;
			case 1: //Rescan
				w.$TelescopeListi = w.$TelescopeList.length;
				w.$Telescope_List( 1 ); //rescan and show found due to the end of list
				break;
			case 2: //Step forward in the target list
				w.$Telescope_List( 1 );//step forward, scan after the end of the list
				if( w.$TelescopeSteering > 1 )
					w.$Telescope_Steer();//turn to the target
				break;
			case 3: //Step back in the target list
				w.$Telescope_List( -1 );//step forward, scan after the end of the list
				if( w.$TelescopeSteering > 1 )
					w.$Telescope_Steer();//turn to the target
				break;
		}
//		player.consoleMessage( menu[ this.$Telescopeeq_MenuItem ][ 0 ], 5 );//debug
	} else { //settings
		var subitem = this.$Telescopeeq_GetSubItem( item ) + 1; //step to the next subitem in the current settings
		var submenu = menu[ item ];
		if( subitem >= submenu.length ) subitem = 1; //back to the first subitem (0. is the menuitem)
		switch( item ) {
			case 4: //Lightballs
				missionVariables.$TelescopeMenuLightballs = subitem;
				w.$Telescope_SetLightballs( subitem );
				break;
			case 5: //Sniper ring km
				missionVariables.$TelescopeMenuSniper = subitem;
				w.$Telescope_SetSniper( subitem );
				break;
			case 6: //Steering
				missionVariables.$TelescopeMenuSteering = subitem;
				w.$Telescope_SetSteering( subitem );
				break;
			case 7: //Targets
				missionVariables.$TelescopeMenuTargets = subitem;
				w.$Telescope_SetTargets( subitem );
				break;
			case 8: //Visual target
				missionVariables.$TelescopeMenuVisual = subitem;
				w.$Telescope_SetVisual( subitem );
				w.$Telescope_VClearS();
				if( w.$TelescopeFixedTel != 1 )
					w.$Telescope_VShow(); //repaint visual target and ring
				else player.consoleMessage("Your cheaply fixed Telescope can not show visual target, buy full repair.",5);
//				player.consoleMessage(w.$TelescopeVSize+" "+w.$TelescopeVZoomSize ); //debug
				break;
			case 9: //Visual target size
				missionVariables.$TelescopeMenuVisualSize = subitem;
				if(!(missionVariables.$TelescopeMenuVisual > 0)
					|| missionVariables.$TelescopeMenuVisual == 1 ) {
					missionVariables.$TelescopeMenuVisual = 2; //must at least wp off
					w.$Telescope_SetVisual( 2 );
				}
				w.$Telescope_SetVisualSize( subitem );
				w.$Telescope_VClearS();
				if( w.$TelescopeFixedTel != 1 )
					w.$Telescope_VShow(); //repaint visual target and ring
				else player.consoleMessage("Your cheaply fixed Telescope can not show visual target, buy full repair.",5);
//				player.consoleMessage(subitem+" "+w.$TelescopeVSize+" "+w.$TelescopeVZoomSize ); //debug
				break;
		}
		//show subitem in settings
		player.consoleMessage( menu[ this.$Telescopeeq_MenuItem ][ 0 ]
			+" "+menu[ this.$Telescopeeq_MenuItem ][ subitem ], 5 );
	}
}

this.mode = function ()
{
	this.$Telescopeeq_MenuItem++;//step forward in the current menu
	var menu = this.$Telescopeeq_Menu;
	if( this.$Telescopeeq_MenuItem >= menu.length ) this.$Telescopeeq_MenuItem = 0; //back to the first menu item
	var sub = "";
	var item = this.$Telescopeeq_MenuItem;
	var subitem = this.$Telescopeeq_GetSubItem( item );
	if( menu[ item ][ subitem ] ) sub = " " + menu[ item ][ subitem ]; //no subitem with commands
	player.consoleMessage( menu[ item ][ 0 ] + sub, 5 );
}


//Telescope primable equipment method
this.$Telescopeeq_GetSubItem = function ( item ) {
	var w = worldScripts["telescope"];
	switch( item ) {
		case 4: //Lightballs
			var m = missionVariables.$TelescopeMenuLightballs;
			if( m > 0 ) return( m );
			if( !w.$TelescopeLightBalls ) return( 1 ); //off
			if( !w.$TelescopeShipLightBalls ) return( 2 ); //ship off
			if( !w.$TelescopeMassLockBorders ) return( 3 ); //masslockborders off
			if( !w.$TelescopeLargeLightBalls ) return( 4 ); //small
			return( 4 ); //large
		case 5: //Sniper ring km
			var m = missionVariables.$TelescopeMenuSniper;
			if( m > 0 ) return( m );
			var max = w.$TelescopeSniperRange;
			var min = w.$TelescopeSniperMinRange;
			if( max == min ) return( 1 ); //off
			var p = 0; //max = 25.6km
			if( max > 25600 ) p = 3; //add this to reach subitems with max = 30km
			if( min <= 5000 ) return( 2 + p ); // "5-25.6" or "5-30"
			if( min >= 15000 ) return( 4 + p ); // "15-25.6" or "15-30"
			return( 3 + p ); // "10-25.6" or "10-30"
		case 6: //Steering
			var m = missionVariables.$TelescopeMenuSteering;
			if( m > 0 ) return( m );
			return( w.$TelescopeSteering + 1 );
		case 7: //Targets
			var m = missionVariables.$TelescopeMenuTargets;
			if( m > 0 ) return( m );
			if( w.$TelescopeRedAlertLimiter ) return( 1 ); //20 and limitation in red alert
			if( w.$TelescopeTargets <= 50 ) return( 2 ); //50
			if( w.$TelescopeTargets >= 200 ) return( 4 ); //200
			return( 3 ); //100
		case 8: //Visual target
			var m = missionVariables.$TelescopeMenuVisual;
			if( m > 0 ) return( m );
			if( w.$TelescopeVZoomSize <= 0 ) return( 1 ); //off
			if( !w.$TelescopeShowVisualTarget ) return( 2 ); //weapons off
			if( !w.$TelescopeRing ) return( 3 ); //no ring
			if( !w.$TelescopeShowVisualStation ) return( 4 ); //no station
			if( !w.$TelescopeShowVisualQuestionMark ) return( 5 ); //no "?"
			return( 6 ); //all
		case 9: //Visual target size (VZoomSize=0 if full off)
			var m = missionVariables.$TelescopeMenuVisualSize;
			if( m > 0 ) return( m );
			var size = w.$TelescopeVSize;
			if( !w.$TelescopeRing ) size -= 2;
			if( !size ) return( 5 ); //default
			if( size < 2 ) return( 1 );
			if( size > 7 ) return( 8 );
			return( size );
	}
	return( -2 ); //no subitem with commands
}


/* //old events
this.activated = function ()
{	//lock the nearest target
	w.$Telescope_Nearest();
	w.$Telescope_Steer();//turn to the target
}

this.mode = function ()
{	//lock the most centered target
	w.$Telescope_MostCentered( null, "mode", false );
	w.$Telescope_Steer();//turn to the current target
//	w.$Telescope_List( 0 );//show target name
}
*/

//this.___ = function () { //step forward - need new button
//	w.$Telescope_List( 1 );
//}

//this.___ = function () { //step backward - need new button
//	w.$Telescope_List( -1 );
//}

//this.___ = function () { //turn on and off visual target - need new button
//	if( w.$TelescopeShowVisualTarget )
//		w.$TelescopeShowVisualTarget = false;
//	else w.$TelescopeShowVisualTarget = true;
//}